unit UFormAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, Menus;

type
  TFormAbout = class(TForm)
    ButtonClose: TButton;
    LabelTitle: TLabel;
    ImageLetters: TImage;
    ImageBox: TImage;
    LabelVersion: TLabel;
    LabelCopyright: TLabel;
    LabelHomepage: TLabel;
    LabelHomepageLink: TLabel;
    LabelSeeAlso: TLabel;
    LabelSeeAlsoLink: TLabel;
    PopupMenuCopy: TPopupMenu;
    PopupItemCopy: TMenuItem;
    LabelLicense: TLabel;
    LabelLicenseLink: TLabel;
    LabelSupport: TLabel;
    LabelSupportLink: TLabel;
    LabelLicenseFullText: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure LabelLinkClick(Sender: TObject);
    procedure LabelContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
    procedure PopupItemCopyClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
  end;

var
  FormAbout: TFormAbout;

implementation

uses
  ShellAPI, Clipbrd, UVerInfo;

const
  LicenseText =
    'This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.'#13#10 +
    'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.'#13#10 +
    'You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.';

{$R *.dfm}

procedure TFormAbout.FormCreate(Sender: TObject);
begin
  with TFileVersionInformation.Create(Application.ExeName) do
    try
      LabelTitle.Caption := Application.Title + Format(' %d.%d', [ProductVersion.Version, ProductVersion.SubVersion]);
      LabelVersion.Caption := Format('Version %d.%d.%d Build %d [%s]', [FileVersion.Version, FileVersion.SubVersion, FileVersion.Revision, FileVersion.Build, SpecialBuild]);
      LabelCopyright.Caption := 'Copyright ' + StringReplace(LegalCopyRight, '&', '&&', [rfReplaceAll]);
    finally
      Free;
    end;
  LabelLicense.Caption := LicenseText;
end;

procedure TFormAbout.LabelLinkClick(Sender: TObject);
var
  LinkURL: String;
begin
  if Sender is TLabel then begin
    LinkURL := TLabel(Sender).Caption;
    case TLabel(Sender).Tag of
      2: LinkURL := 'mailto:' + LinkURL;
    end;
    ShellExecute(Handle, 'open', PChar(LinkURL), nil, nil, SW_SHOW);
  end;
end;

procedure TFormAbout.LabelContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
  if Sender is TLabel then
    PopupMenuCopy.Tag := Integer(Sender);
end;

procedure TFormAbout.PopupItemCopyClick(Sender: TObject);
begin
  if TObject(PopupMenuCopy.Tag) is TLabel then
    with TClipboard.Create do
      try
        AsText := TLabel(PopupMenuCopy.Tag).Caption;
      finally
        Free;
      end;
end;

end.
